#---------------------------------------------------------------------#
# Ĵ adj_meeting                                      #
#                                                                     #
# Copyright (c) 1995 matsuo@present.forus.or.jp. All rights reserved. #
#---------------------------------------------------------------------#


%MEETING_USER_KEY =
    ('comment' => '');

sub MEETING_USER_FILE
{
    local($meeting,$user) = @_;

    "$MEETING_USER_DIR/" . &cgi_encode($meeting) . "/" . &cgi_encode($user);
}

sub read_meeting_user
{
    local($meeting,$user) = @_;

    return &read_db(&MEETING_USER_FILE($meeting,$user));
}

sub save_meeting_user
{
    local($meeting,$user,%meeting_user) = @_;

    unless(keys %meeting_user)	# ǡʤлäʤȤˤ
    {
	&delete_meeting_user($meeting,$user);
    }

    local($dir) = &MEETING_USER_FILE($meeting);
    unless(-e $dir)
    {
	mkdir $dir,0777;
    }

    &save_db(&MEETING_USER_FILE($meeting,$user),%meeting_user)
	    || &print_page(&MEETING_USER_FILE($meeting,$user)
			   . "˽񤭹ޤǤ",
			   'MAIN','','','ᥤ˥塼/goto MENU');
}

sub meeting_user_info
{
    local(%meeting_user) = @_;

    local($key,$text);

    foreach $key (sort keys %meeting_user)
    {
	if(defined($MEETING_USER_KEY{$key}))
	{
	    $text .= "$MEETING_USER_KEY{$key}:\t$meeting_user{$key}<br>\n";
	}
	else
	{
	    $text .= "$key:\t$meeting_user{$key}<br>\n";
	}
    }

    return $text;
}

sub delete_meeting_user
{
    local($meeting,$user) = @_;

    unlink(&MEETING_USER_FILE($meeting,$user));

    &print_page(":$meetingˤϻäʤȤˤޤ",
	'MAIN','','','ᥤ˥塼/goto MENU');
}

sub delete_all_meetings_user
{
    local($user) = @_;

    local($cgi_user) = &cgi_encode($user);

    unlink(<$MEETING_USER_DIR/*/$cgi_user>);
#	|| &print_page("ǤޤǤƥ२顼? [$user,$cgi_user]",
#	'MAIN','','','ᥤ˥塼/goto MENU');
}

sub get_member
{
    local($meeting) = @_;

    local(@member,$file);

    $file = "$MEETING_USER_DIR/" . &cgi_encode($meeting) . "/";
		
    @member = (<$file*>);
    @member = grep(s/$file(.*)/$1/,@member);

    return grep(&cgi_decode($_),@member);
}


1;
