#---------------------------------------------------------------------#
# Ĵ adj_meeting                                      #
#                                                                     #
# Copyright (c) 1995 matsuo@present.forus.or.jp. All rights reserved. #
#---------------------------------------------------------------------#


@USER_KEY_REQUIRED =
    ('id',
     'passwd',
     'name',
     'address');

%USER_KEY =
    ('id' => 'ID',
     'passwd' => 'ѥ',
     'name' => '̾',
     'address' => '᡼륢ɥ쥹',
     'homepage' => 'ۡڡURL',
     'figure' => '̿URL',
     'comment' => '');

# 桼Υѥɥå
sub check_user
{
    local(%data) = @_;

    local(%user) = &read_user($data{'id'});

    unless($user{'passwd'} eq $data{'passwd'})	# ѥɤ㤦
    {
	&print_page("login incorrect");
    }

    return(%user);
}

#  id
#  %user
sub read_user
{
    local($id) = @_;

    local($key,$value,%user);

    %user = &read_db(&USER_FILE($id));
    %user || return 0;
    $user{'id'} = $id;

    return %user;
}

sub save_user
{
    local(%user) = @_;

    &check_user_required(%user);
    &save_db(&USER_FILE($user{'id'}),%user)
	|| &print_page(&USER_FILE($user{'id'}) . "˽񤭹ޤǤ",
	'MAIN','','','ᥤ˥塼/goto MENU');
}

sub user_info
{
    local(%user) = @_;

    local($key,$text);

    foreach $key (sort keys %user)
    {
	if(defined($USER_KEY{$key}))
	{
	    $text .= "$USER_KEY{$key}:\t$user{$key}<br>\n";
	}
	else
	{
	    $text .= "$key:\t$user{$key}<br>\n";
	}
    }

    return($text);
}

sub check_user_required
{
    local(%user) = @_;

    local($key);

    foreach $key (@USER_KEY_REQUIRED)
    {
	defined($user{$key})
	    || &print_page("$USER_KEY{$key}ꤵƤޤ",
			   'MAIN','','','ᥤ˥塼/goto MENU');
    }
}

sub delete_user
{
    local($user) = @_;
	
    &delete_all_meetings_user($user);

    unlink(&USER_FILE($user))
	|| &print_page("ǤޤǤƥ२顼? [$user]",
		       'MAIN','','','ᥤ˥塼/goto MAIN');

    &print_page("$userξޤ",
		'LOGIN','','','̤/LOGIN');
}

sub USER_FILE
{
    local($id) = @_;

    "$USER_DIR/" . &cgi_encode($id);
}

sub member_list
{
    local(@member) = @_;

    local(@text,$member,@address);

    $text = "Хꥹ<hr>\n";
    foreach $member (@member)
    {
	unless(%user = read_user($member)){ next; }

	$text .= &user_page(%user) . "\n<hr>\n";
	push(@address,$user{'address'});
    }

    $text .= "<a href=mailto:" . join(",",@address) .
	">ؤΥ᡼</a>\n";

    return $text;
}

sub user_page
{
    local(%user) = @_;

    local($name,$figure,$comment);

    if(defined($user{'homepage'}))
    {
	$name = "<a href=$user{'homepage'}>$user{'name'}</a>";
    }
    else
    {
	$name = "$user{'name'}";
    }

    if(defined($user{'figure'}))
    {
	$figure =
    "\n<img align=top src=$user{'figure'} alt=\"(̿inline image)\"><br>";
    }

    if(defined($user{'comment'}))
    {
	$comment = "<dt>\n<dd>$user{'comment'}<br>\n";
    }

    return
"<dl><dt>ID
<dd>$user{'id'}
<dt>̾
<dd>$name$figure
<dt>ɥ쥹
<dd><a href=mailto:$user{'address'}>$user{'address'}</a><br>
$comment</dl>";
}

sub get_all_user
{
    local(@user,$file);

    $file = "$USER_DIR/";
		
    @member = (<$file*>);
    @member = grep(s/$file(.*)/$1/,@member);

    return grep(&cgi_decode($_),@member);
}

1;
